package com.yifu.cloud.plus.v1.yifu.common.dapr.util;

import com.yifu.cloud.plus.v1.yifu.admin.api.entity.SysDataAuth;
import com.yifu.cloud.plus.v1.yifu.common.core.constant.CacheConstants;
import com.yifu.cloud.plus.v1.yifu.common.core.constant.CommonConstants;
import com.yifu.cloud.plus.v1.yifu.common.core.constant.SecurityConstants;
import com.yifu.cloud.plus.v1.yifu.common.core.util.Common;
import com.yifu.cloud.plus.v1.yifu.common.core.vo.YifuUser;
import com.yifu.cloud.plus.v1.yifu.common.dapr.config.DaprUpmsProperties;
import com.yifu.cloud.plus.v1.yifu.common.mybatis.base.BaseEntity;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.cache.Cache;
import org.springframework.cache.CacheManager;
import org.springframework.cache.support.SimpleValueWrapper;

/**
 * @author hgw
 * 2022-9-13 16:14:34
 * @Description 公共获取菜单权限的工具
 */
@EnableConfigurationProperties({DaprUpmsProperties.class})
@RequiredArgsConstructor
@Slf4j
public class MenuUtil {
	// 缓存信息
	private final CacheManager cacheManager;

	private final DaprUpmsProperties daprUpmsProperties;
	private final String DEPT = "#deptId";

	public void setAuthSql(YifuUser user, BaseEntity entity) {
		// 普通用户：
		if (CommonConstants.ONE_STRING.equals(user.getSystemFlag())) {

			// 菜单id
			String menuId = entity.getMId();
			if (Common.isNotNull(menuId)) {
				String linkId = user.getId();
				int linkType = 1; // 用户
				SysDataAuth sysDataAuth = new SysDataAuth();
				sysDataAuth.setLinkId(linkId);
				sysDataAuth.setLinkType(linkType);
				// 获取缓存菜单权限的步骤：
				Cache cache = cacheManager.getCache(CacheConstants.DATA_AUTH_DETAILS + linkType);
				Object obj = null;
				if (cache != null) {
					obj = cache.get(linkId + CommonConstants.DOWN_LINE_STRING + menuId);
					if (Common.isEmpty(obj)) {
						HttpDaprUtil.invokeMethodPost(daprUpmsProperties.getAppUrl(), daprUpmsProperties.getAppId()
								, "/dataAuth/refreshAuth", sysDataAuth, SysDataAuth.class, SecurityConstants.FROM_IN);
						obj = cache.get(linkId + CommonConstants.DOWN_LINE_STRING + menuId);
						if (Common.isEmpty(obj)) {
							linkId = user.getUserGroup();
							linkType = 0; // 用户组
							cache = cacheManager.getCache(CacheConstants.DATA_AUTH_DETAILS + linkType);
							if (cache != null) {
								obj = cache.get(linkId + CommonConstants.DOWN_LINE_STRING + menuId);
								if (Common.isEmpty(obj)) {
									sysDataAuth.setLinkId(linkId);
									sysDataAuth.setLinkType(linkType);
									HttpDaprUtil.invokeMethodPost(daprUpmsProperties.getAppUrl(), daprUpmsProperties.getAppId()
											, "/dataAuth/refreshAuth", sysDataAuth, SysDataAuth.class, SecurityConstants.FROM_IN);
									obj = cache.get(linkId + CommonConstants.DOWN_LINE_STRING + menuId);
								}
							}
						}
					}
				}
				if (Common.isNotNull(obj)) {
					SimpleValueWrapper objs = (SimpleValueWrapper) obj;
					if (objs != null) {
						String sql = String.valueOf(objs.get());
						if (sql.contains(DEPT)) {
							entity.setIsDept(CommonConstants.ONE_INT);
						}
						if (sql.contains("#create_by")) {
							sql = sql.replace("#create_by", user.getId());
						}
						if (sql.contains("#settleDomainId")) {
							// TODO - 获取人员项目权限
							// sql = sql.replace("#settleDomainId", ",'1','2' ")
							sql = sql.replace("or a.settle_domain_id in ('0'#settleDomainId) ", "");
						}
						if (sql.contains(DEPT)) {
							sql = sql.replace(DEPT, String.valueOf(user.getDeptId()));
							//sql = sql.replace(" or dept.dept_id = #deptId ", "")
						}
						entity.setAuthSql(sql);
					}
				}
			}
		}
	}
}
